Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2528)
@@ -5,14 +5,19 @@
    !!======================================================================
    !!======================================================================
-   !! History :  7.0  !  91-11  (G. Madec)  Original code
-   !!                 !  93-03  (M. Guyon)  symetrical conditions
-   !!                 !  95-02  (M. Levy)   passive tracers
-   !!                 !  96-02  (G. Madec & M. Imbard)  opa release 8.0
-   !!            8.0  !  96-04  (A. Weaver)  Euler forward step
-   !!            8.2  !  99-02  (G. Madec, N. Grima)  semi-implicit pressure grad.
-   !!            8.5  !  02-08  (G. Madec)  F90: Free form and module
-   !!                 !  02-11  (C. Talandier, A-M Treguier) Open boundaries
-   !!            9.0  !  04-03  (C. Ethe) passive tracers
-   !!                 !  07-02  (C. Deltel) Diagnose ML trends for passive tracers
+   !! History :  7.0  !  1991-11  (G. Madec)  Original code
+   !!                 !  1993-03  (M. Guyon)  symetrical conditions
+   !!                 !  1995-02  (M. Levy)   passive tracers
+   !!                 !  1996-02  (G. Madec & M. Imbard)  opa release 8.0
+   !!            8.0  !  1996-04  (A. Weaver)  Euler forward step
+   !!            8.2  !  1999-02  (G. Madec, N. Grima)  semi-implicit pressure grad.
+   !!  NEMO      1.0  !  2002-08  (G. Madec)  F90: Free form and module
+   !!                 !  2002-08  (G. Madec)  F90: Free form and module
+   !!                 !  2002-11  (C. Talandier, A-M Treguier) Open boundaries
+   !!                 !  2004-03  (C. Ethe) passive tracers
+   !!                 !  2007-02  (C. Deltel) Diagnose ML trends for passive tracers
+   !!            2.0  !  2006-02  (L. Debreu, C. Mazauric) Agrif implementation
+   !!            3.0  !  2008-06  (G. Madec)  time stepping always done in trazdf
+   !!            3.1  !  2009-02  (G. Madec, R. Benshila)  re-introduce the vvl option
+   !!            3.3  !  2010-06  (C. Ethe, G. Madec) Merge TRA-TRC
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -24,12 +29,14 @@
    !! * Modules used
    USE oce_trc         ! ocean dynamics and tracers variables
-   USE trp_trc             ! ocean passive tracers variables
+   USE trc             ! ocean passive tracers variables
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE trctrp_lec      ! pasive tracers transport
    USE prtctl_trc      ! Print control for debbuging
-   USE trdmld_trc
-   USE trdmld_trc_oce
+   USE trdmod_oce
+   USE trdtra
+   USE tranxt
+# if defined key_agrif
    USE agrif_top_update
    USE agrif_top_interp
+# endif
 
    IMPLICIT NONE
@@ -38,8 +45,10 @@
    !! * Routine accessibility
    PUBLIC trc_nxt          ! routine called by step.F90
+
+  REAL(wp), DIMENSION(jpk) ::   r2dt
    !!----------------------------------------------------------------------
-   !!   TOP 1.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -70,112 +79,78 @@
       !! ** Action  : - update trb, trn
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   ztrtrd => ua    ! use ua as 3D workspace 
       !! * Arguments
       INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
       !! * Local declarations
-      INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
+      INTEGER  ::   jk, jn   ! dummy loop indices
       REAL(wp) ::   zfact            ! temporary scalar
       CHARACTER (len=22) :: charout
+      REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  ztrdt 
       !!----------------------------------------------------------------------
 
-      IF( kt == nittrc000 .AND. lwp ) THEN
+      IF( kt == nit000 .AND. lwp ) THEN
          WRITE(numout,*)
          WRITE(numout,*) 'trc_nxt : time stepping on passive tracers'
       ENDIF
 
+      ! Update after tracer on domain lateral boundaries
       DO jn = 1, jptra
+         CALL lbc_lnk( tra(:,:,:,jn), 'T', 1. )   
+      END DO
 
-         ! 0. Lateral boundary conditions on tra (T-point, unchanged sign)
-         ! ---------------------------------============
-         CALL lbc_lnk( tra(:,:,:,jn), 'T', 1. )   
-         
-         !                                                ! ===============
-         DO jk = 1, jpk                                   ! Horizontal slab
-            !                                             ! ===============
-            ! 1. Leap-frog scheme (only in explicit case, otherwise the 
-            ! -------------------  time stepping is already done in trczdf)
-            IF( l_trczdf_exp .AND. ( ln_trcadv_cen2 .OR. ln_trcadv_tvd) ) THEN
-               zfact = 2. * rdttra(jk) * FLOAT(ndttrc) 
-               IF( neuler == 0 .AND. kt == nittrc000 ) zfact = rdttra(jk) * FLOAT(ndttrc) 
-               tra(:,:,jk,jn) = ( trb(:,:,jk,jn) + zfact * tra(:,:,jk,jn) ) * tmask(:,:,jk)
-            ENDIF
-
-         END DO
 
 #if defined key_obc
-        CALL ctl_stop( '          Passive tracers and Open Boundary condition can not be used together ' &
-           &           '          Check in trc_nxt routine' )
+!!      CALL obc_trc( kt )               ! OBC open boundaries
+#endif
+#if defined key_bdy
+!!      CALL bdy_trc( kt )               ! BDY open boundaries
+#endif
+#if defined key_agrif
+      CALL Agrif_trc                   ! AGRIF zoom boundaries
 #endif
 
+
+      ! set time step size (Euler/Leapfrog)
+      IF( neuler == 0 .AND. kt ==  nit000) THEN  ;  r2dt(:) =     rdttrc(:)   ! at nit000             (Euler)
+      ELSEIF( kt <= nit000 + 1 )           THEN  ;  r2dt(:) = 2.* rdttrc(:)   ! at nit000 or nit000+1 (Leapfrog)
+      ENDIF
+
+      ! trends computation initialisation
+      IF( l_trdtrc )  THEN
+         ALLOCATE( ztrdt(jpi,jpj,jpk,jptra) )  !* store now fields before applying the Asselin filter
+         ztrdt(:,:,:,:)  = trn(:,:,:,:)
+      ENDIF
+      ! Leap-Frog + Asselin filter time stepping
+      IF( neuler == 0 .AND. kt == nit000 ) THEN        ! Euler time-stepping at first time-step
+         !                                             ! (only swap)
+         DO jn = 1, jptra
+            DO jk = 1, jpkm1
+               trn(:,:,jk,jn) = tra(:,:,jk,jn)
+            END DO
+         END DO
+         !                                              
+      ELSE
+         ! Leap-Frog + Asselin filter time stepping
+         IF( lk_vvl ) THEN   ;   CALL tra_nxt_vvl( kt, 'TRC', trb, trn, tra, jptra )      ! variable volume level (vvl) 
+         ELSE                ;   CALL tra_nxt_fix( kt, 'TRC', trb, trn, tra, jptra )      ! fixed    volume level 
+         ENDIF
+      ENDIF
+
 #if defined key_agrif
-         !                                             ! ===============
-      END DO                                           !   End of slab
-      !                                                ! ===============
-      ! Interp tracers on boundaries (coarse => fine)
-      CALL Agrif_trc
-      !                                                ! ===============
-      DO jn = 1, jptra                                 ! Horizontal slab
-         !                                             ! ===============
-#endif
+      ! Update tracer at AGRIF zoom boundaries
+      IF( .NOT.Agrif_Root() )    CALL Agrif_Update_Trc( kt )      ! children only
+#endif      
 
-         DO jk = 1, jpk  
-
-            ! 2. Time filter and swap of arrays
-            ! ---------------------------------
-            IF ( ln_trcadv_cen2 .OR. ln_trcadv_tvd  ) THEN
-
-               IF( neuler == 0 .AND. kt == nittrc000 ) THEN
-                  DO jj = 1, jpj
-                     DO ji = 1, jpi
-                        trb(ji,jj,jk,jn) = trn(ji,jj,jk,jn)
-                        trn(ji,jj,jk,jn) = tra(ji,jj,jk,jn)
-                        tra(ji,jj,jk,jn) = 0.
-                     END DO
-                  END DO
-                  IF( l_trdtrc )   ztrtrd(:,:,:) = 0.e0           !    no trend
-               ELSE
-                  IF( l_trdtrc ) THEN                             !    Asselin trend
-                     DO jj = 1, jpj
-                        DO ji = 1, jpi
-                           ztrtrd(ji,jj,jk) = atfp * ( trb(ji,jj,jk,jn) - 2*trn(ji,jj,jk,jn) + tra(ji,jj,jk,jn) )
-                        END DO
-                     END DO
-                  ENDIF
-
-                  DO jj = 1, jpj
-                     DO ji = 1, jpi
-                        trb(ji,jj,jk,jn) = atfp  * ( trb(ji,jj,jk,jn) + tra(ji,jj,jk,jn) ) + atfp1 * trn(ji,jj,jk,jn)
-                        trn(ji,jj,jk,jn) = tra(ji,jj,jk,jn)
-                        tra(ji,jj,jk,jn) = 0.
-                     END DO
-                  END DO
-               ENDIF
-            ELSE                                                  ! >> EULER-FORWARD schemes (SMOLAR, MUSCL)
-               IF( l_trdtrc ) ztrtrd(:,:,:) = 0.e0                !    no trend
-
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     trb(ji,jj,jk,jn) = tra(ji,jj,jk,jn)
-                     trn(ji,jj,jk,jn) = tra(ji,jj,jk,jn)
-                     tra(ji,jj,jk,jn) = 0.
-                  END DO
-               END DO
-
-            ENDIF
-            !                                             ! ===============
-         END DO                                           !   End of slab
-         !                                                ! ===============
-
-         IF( l_trdtrc ) THEN                                      ! trends
-            DO jk = 1, jpk
-               zfact = 2. * rdttra(jk) * FLOAT(ndttrc)
-               ztrtrd(:,:,jk) = ztrtrd(:,:,jk) / zfact            ! n.b. ztrtrd=0 in Euler-forward case
+      ! trends computation
+      IF( l_trdtrc ) THEN                                      ! trends
+         DO jn = 1, jptra
+            DO jk = 1, jpkm1
+               zfact = 1.e0 / r2dt(jk)  
+               ztrdt(:,:,jk,jn) = ( trb(:,:,jk,jn) - ztrdt(:,:,jk,jn) ) * zfact 
+               CALL trd_tra( kt, 'TRC', jn, jptra_trd_atf, ztrdt )
             END DO
-            IF (luttrd(jn)) CALL trd_mod_trc( ztrtrd, jn, jptrc_trd_atf, kt )
-         ENDIF
-         !                                                        ! ===========
-      END DO                                                      ! tracer loop
-      !                                                           ! ===========
-
+         END DO
+         DEALLOCATE( ztrdt )
+      END IF
+      !
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
          WRITE(charout, FMT="('nxt')")
@@ -183,10 +158,5 @@
          CALL prt_ctl_trc(tab4d=trn, mask=tmask, clinfo=ctrcnm)
       ENDIF
-
-#if defined key_agrif
-      IF (.NOT.Agrif_Root())    CALL Agrif_Update_Trc( kt )
-#endif      
-
-
+      !
    END SUBROUTINE trc_nxt
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 2528)
@@ -14,7 +14,7 @@
    !!----------------------------------------------------------------------
    USE oce_trc             ! ocean dynamics and tracers variables
-   USE trp_trc             ! ocean passive tracers variables
-   USE trdmld_trc
-   USE trdmld_trc_oce
+   USE trc                 ! ocean passive tracers variables
+   USE trdmod_oce
+   USE trdtra
    USE lib_mpp
    USE prtctl_trc          ! Print control for debbuging
@@ -28,7 +28,7 @@
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 1.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
    
@@ -54,5 +54,5 @@
       !!----------------------------------------------------------------------
 
-      IF( kt == nittrc000 ) THEN
+      IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'trc_rad : Correct artificial negative concentrations '
@@ -139,5 +139,5 @@
                   DO ji = 1, jpi
                      zvolk  = cvol(ji,jj,jk)
-# if defined key_off_degrad
+# if defined key_degrad
                      zvolk  = zvolk * facvol(ji,jj,jk)
 # endif
@@ -180,6 +180,6 @@
                ztrtrdb(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrdb(:,:,:) ) * zs2rdt
                ztrtrdn(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrdn(:,:,:) ) * zs2rdt 
-               IF (luttrd(jn)) CALL trd_mod_trc( ztrtrdb, jn, jptrc_trd_radb, kt )       ! Asselin-like trend handling
-               IF (luttrd(jn)) CALL trd_mod_trc( ztrtrdn, jn, jptrc_trd_radn, kt )       ! standard     trend handling
+               CALL trd_tra( kt, 'TRC', jn, jptra_trd_radb, ztrtrdb )       ! Asselin-like trend handling
+               CALL trd_tra( kt, 'TRC', jn, jptra_trd_radn, ztrtrdn )       ! standard     trend handling
               !
             ENDIF
@@ -208,9 +208,9 @@
             IF( l_trdtrc ) THEN
                !
-               zs2rdt = 1. / ( 2. * rdt * FLOAT(ndttrc) )
+               zs2rdt = 1. / ( 2. * rdt * FLOAT(nn_dttrc) )
                ztrtrdb(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrdb(:,:,:) ) * zs2rdt
                ztrtrdn(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrdn(:,:,:) ) * zs2rdt 
-               IF (luttrd(jn)) CALL trd_mod_trc( ztrtrdb, jn, jptrc_trd_radb, kt )       ! Asselin-like trend handling
-               IF (luttrd(jn)) CALL trd_mod_trc( ztrtrdn, jn, jptrc_trd_radn, kt )       ! standard     trend handling
+               CALL trd_tra( kt, 'TRC', jn, jptra_trd_radb, ztrtrdb )       ! Asselin-like trend handling
+               CALL trd_tra( kt, 'TRC', jn, jptra_trd_radn, ztrtrdn )       ! standard     trend handling
               !
             ENDIF
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2528)
@@ -4,9 +4,9 @@
    !! Ocean passive tracers:  surface boundary condition
    !!======================================================================
-   !! History :  8.2  !  98-10  (G. Madec, G. Roullet, M. Imbard)  Original code
-   !!            8.2  !  01-02  (D. Ludicone)  sea ice and free surface
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!            9.0  !  04-03  (C. Ethe)  adapted for passive tracers
-   !!                 !  06-08  (C. Deltel) Diagnose ML trends for passive tracers
+   !! History :  8.2  !  1998-10  (G. Madec, G. Roullet, M. Imbard)  Original code
+   !!            8.2  !  2001-02  (D. Ludicone)  sea ice and free surface
+   !!            8.5  !  2002-06  (G. Madec)  F90: Free form and module
+   !!            9.0  !  2004-03  (C. Ethe)  adapted for passive tracers
+   !!                 !  2006-08  (C. Deltel) Diagnose ML trends for passive tracers
    !!==============================================================================
 #if defined key_top
@@ -18,8 +18,8 @@
    !! * Modules used
    USE oce_trc             ! ocean dynamics and active tracers variables
-   USE trp_trc                 ! ocean  passive tracers variables
+   USE trc                 ! ocean  passive tracers variables
    USE prtctl_trc          ! Print control for debbuging
-   USE trdmld_trc
-   USE trdmld_trc_oce
+   USE trdmod_oce
+   USE trdtra
 
    IMPLICIT NONE
@@ -32,7 +32,7 @@
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   TOP 1.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -65,10 +65,11 @@
       !! * Local declarations
       INTEGER  ::   ji, jj, jn           ! dummy loop indices
-      REAL(wp) ::   ztra, zsrau, zse3t   ! temporary scalars
+      REAL(wp) ::   zsrau, zse3t   ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   zemps  ! surface freshwater flux
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
       CHARACTER (len=22) :: charout
       !!----------------------------------------------------------------------
 
-      IF( kt == nittrc000 ) THEN
+      IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'trc_sbc : Passive tracers surface boundary condition'
@@ -76,26 +77,30 @@
       ENDIF
 
+
       IF( l_trdtrc ) ALLOCATE( ztrtrd(jpi,jpj,jpk) )
+
+      IF( lk_offline ) THEN          ! emps in dynamical files contains emps - rnf
+         zemps(:,:) = emps(:,:)  
+      ELSE                           ! Concentration dilution effect on tracer due to evaporation, precipitation, and river runoff
+         IF( lk_vvl ) THEN                      ! volume variable
+            zemps(:,:) = emps(:,:) - emp(:,:)   
+!!ch         zemps(:,:) = 0.
+         ELSE                                   ! linear free surface
+            IF( ln_rnf ) THEN  ;  zemps(:,:) = emps(:,:) - rnf(:,:)   !  E-P-R
+            ELSE               ;  zemps(:,:) = emps(:,:)
+            ENDIF 
+         ENDIF 
+      ENDIF 
 
       ! 0. initialization
       zsrau = 1. / rau0
-      IF( .NOT. ln_sco )  zse3t = 1. / fse3t(1,1,1)
-
       DO jn = 1, jptra
-         ! 1. Concentration dillution effect on tra
+         !
          IF( l_trdtrc ) ztrtrd(:,:,:) = tra(:,:,:,jn)  ! save trends
-
+         !                                             ! add the trend to the general tracer trend
          DO jj = 2, jpj
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               IF( ln_sco ) zse3t = 1. / fse3t(ji,jj,1)
-               ! concent./dilut. effect
-               ztra = emps(ji,jj) * zsrau * trn(ji,jj,1,jn) * zse3t * tmask(ji,jj,1)
-               ! add the trend to the general tracer trend
-               tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + ztra
-#if defined key_trc_diatrd
-               IF( luttrd(jn) ) &
-               &    trtrd(ji,jj,1,ikeep(jn),jpdiatrc) = trtrd(ji,jj,1,ikeep(jn),jpdiatrc) + ztra
-#endif
-
+               zse3t = 1. / fse3t(ji,jj,1)
+               tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + zemps(ji,jj) *  zsrau * trn(ji,jj,1,jn) * zse3t
             END DO
          END DO
@@ -103,18 +108,14 @@
          IF( l_trdtrc ) THEN
             ztrtrd(:,:,:) = tra(:,:,:,jn) - ztrtrd(:,:,:)
-            IF (luttrd(jn)) CALL trd_mod_trc(ztrtrd, jn, jptrc_trd_sbc, kt)
+            CALL trd_tra( kt, 'TRC', jn, jptra_trd_nsr, ztrtrd )
          END IF
-
          !                                                       ! ===========
       END DO                                                     ! tracer loop
       !                                                          ! ===========
-
       IF( l_trdtrc ) DEALLOCATE( ztrtrd )
 
-
-      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
-         WRITE(charout, FMT="('sbc')")
-         CALL prt_ctl_trc_info(charout)
-         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
+      IF( ln_ctl )   THEN
+         WRITE(charout, FMT="('sbc ')") ;  CALL prt_ctl_trc_info(charout)
+                                           CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       ENDIF
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 2528)
@@ -5,4 +5,5 @@
    !!======================================================================
    !! History :   1.0  !  2004-03 (C. Ethe) Original code
+   !!             3.3  !  2010-07 (C. Ethe) Merge TRA-TRC
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -13,33 +14,17 @@
    !!----------------------------------------------------------------------
    USE oce_trc         ! ocean dynamics and active tracers variables
-   USE trp_trc         ! ocean passive tracers variables 
-   USE trctrp_lec      ! passive tracers transport parameters
-   USE prtctl_trc      ! Print control for debbuging
-
+   USE trc             ! ocean passive tracers variables 
+   USE trcnam_trp      ! passive tracers transport namelist variables
+   USE trabbl          ! bottom boundary layer               (trc_bbl routine)
    USE trcbbl          ! bottom boundary layer               (trc_bbl routine)
+   USE zdfkpp          ! KPP non-local tracer fluxes         (trc_kpp routine)
    USE trcdmp          ! internal damping                    (trc_dmp routine)
-
-   USE trcldf_bilapg   ! lateral mixing               (trc_ldf_bilapg routine)
-   USE trcldf_bilap    ! lateral mixing                (trc_ldf_bilap routine)
-   USE trcldf_iso      ! lateral mixing                  (trc_ldf_iso routine)
-   USE trcldf_iso_zps  ! lateral mixing              (trc_ldf_iso_zps routine)
-   USE trcldf_lap      ! lateral mixing                  (trc_ldf_lap routine)
- 
+   USE trcldf          ! lateral mixing                      (trc_ldf routine)
+   USE trcadv          ! advection                           (trc_adv routine)
+   USE trczdf          ! vertical diffusion                  (trc_zdf routine)
    USE trcnxt          ! time-stepping                       (trc_nxt routine)
    USE trcrad          ! positivity                          (trc_rad routine)
-
-   USE trcadv_cen2     ! 2nd order centered advection   (trc_adv_cen2 routine)
-   USE trcadv_muscl    ! MUSCL advection               (trc_adv_muscl routine)
-   USE trcadv_muscl2   ! MUSCL2 advection             (trc_adv_muscl2 routine)
-   USE trcadv_tvd      ! TVD advection                   (trc_adv_tvd routine)
-   USE trcadv_smolar   ! SMOLAR advection             (trc_adv_smolar routine)
-
-   USE trczdf_exp      ! vertical diffusion              (trc_zdf_exp routine)
-   USE trczdf_imp      ! vertical diffusion              (trc_zdf_exp routine)
-   USE trczdf_iso      ! vertical diffusion              (trc_zdf_exp routine)
-   USE trczdf_iso_vopt ! vertical diffusion              (trc_zdf_exp routine)
    USE trcsbc          ! surface boundary condition          (trc_sbc routine)
-
-   USE zpshde_trc      ! partial step: hor. derivative   (zps_hde_trc routine)
+   USE zpshde          ! partial step: hor. derivative       (zps_hde routine)
 
 #if defined key_agrif
@@ -55,12 +40,12 @@
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 1.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE trc_trp( kt )
+   SUBROUTINE trc_trp( kstp )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE trc_trp  ***
@@ -71,60 +56,33 @@
       !!              - Update the passive tracers
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::  kt  ! ocean time-step index
-      !!
-      CHARACTER (len=25) :: charout
+      INTEGER, INTENT( in ) ::  kstp  ! ocean time-step index
       !! ---------------------------------------------------------------------
-
-                               CALL trc_sbc( kt )            ! surface boundary condition
-# if defined key_trcbbc
-!!gm bug : this should be control during the initialisation phase, not here!
-       CALL ctl_stop( '  Bottom heat flux not yet implemented with passive tracer         ' &
-           &          '  Check in trc_trp routine ' )
-# endif 
-      !                                                      ! bottom boundary condition
-      IF( lk_trcbbl_dif    )   CALL trc_bbl_dif( kt )            ! diffusive bottom boundary layer scheme
-      IF( lk_trcbbl_adv    )   CALL trc_bbl_adv( kt )            ! advective (and/or diffusive) bottom boundary layer scheme
-
-      IF( lk_trcdmp        )   CALL trc_dmp( kt )            ! internal damping trends
-
-      !                                                      ! horizontal & vertical advection
-      IF( ln_trcadv_cen2   )   CALL trc_adv_cen2  ( kt )         ! 2nd order centered scheme
-      IF( ln_trcadv_muscl  )   CALL trc_adv_muscl ( kt )         ! MUSCL scheme
-      IF( ln_trcadv_muscl2 )   CALL trc_adv_muscl2( kt )         ! MUSCL2 scheme
-      IF( ln_trcadv_tvd    )   CALL trc_adv_tvd   ( kt )         ! TVD scheme
-      IF( ln_trcadv_smolar )   CALL trc_adv_smolar( kt )         ! SMOLARKIEWICZ scheme
-
- 
-      IF( n_cla == 1   ) THEN
-!!gm bug : this should be control during the initialisation phase, not here!
-         WRITE(ctmp1,*) ' Cross Land Advection not yet implemented with passive tracer n_cla = ',n_cla
-         CALL ctl_stop( ctmp1 )
-      ENDIF
-
-      !                                                      ! lateral mixing 
-      IF( l_trcldf_bilapg  )   CALL trc_ldf_bilapg ( kt )        ! s-coord. horizontal bilaplacian
-      IF( l_trcldf_bilap   )   CALL trc_ldf_bilap  ( kt )        ! iso-level bilaplacian 
-      IF( l_trcldf_iso     )   CALL trc_ldf_iso    ( kt )        ! iso-neutral laplacian 
-      IF( l_trcldf_iso_zps )   CALL trc_ldf_iso_zps( kt )        ! partial step iso-neutral laplacian
-      IF( l_trcldf_lap     )   CALL trc_ldf_lap    ( kt )        ! iso-level laplacian
-
+      IF( .NOT. lk_c1d ) THEN
+         !
+                                CALL trc_sbc( kstp )            ! surface boundary condition
+         IF( lk_trabbl )        CALL trc_bbl( kstp )            ! advective (and/or diffusive) bottom boundary layer scheme
+         IF( lk_trcdmp )        CALL trc_dmp( kstp )            ! internal damping trends
+                                CALL trc_adv( kstp )            ! horizontal & vertical advection 
+                                CALL trc_ldf( kstp )            ! lateral mixing
+         IF( .NOT. lk_offline .AND. lk_zdfkpp )    &
+            &                   CALL trc_kpp( kstp )            ! KPP non-local tracer fluxes
 #if defined key_agrif
-      IF(.NOT. Agrif_Root()) CALL Agrif_Sponge_trc               ! tracers sponge
+         IF(.NOT. Agrif_Root()) CALL Agrif_Sponge_trc           ! tracers sponge
 #endif
- 
-      !                                                      ! vertical diffusion
-      IF( l_trczdf_exp     )   CALL trc_zdf_exp     ( kt )       ! explicit time stepping (time splitting scheme)
-      IF( l_trczdf_imp     )   CALL trc_zdf_imp     ( kt )       ! implicit time stepping (euler backward)
-      IF( l_trczdf_iso     )   CALL trc_zdf_iso     ( kt )       ! isopycnal
-      IF( l_trczdf_iso_vo  )   CALL trc_zdf_iso_vopt( kt )       ! vector opt. isopycnal
-
-                               CALL trc_nxt( kt )            ! tracer fields at next time step
-     
-      IF( ln_trcrad )          CALL trc_rad( kt )            ! Correct artificial negative concentrations
-      !                                                      ! especially useful when isopycnal mixing is used
-      !                                                      
-
-      IF( ln_zps .AND. .NOT. lk_trc_c1d )   &              ! Partial steps: now horizontal gradient of passive
-         &                     CALL zps_hde_trc( kt, trb, gtru, gtrv )       ! tracers at the bottom ocean level
+                                CALL trc_zdf( kstp )            ! vertical mixing and after tracer fields
+                                CALL trc_nxt( kstp )            ! tracer fields at next time step     
+         IF( ln_trcrad )        CALL trc_rad( kstp )            ! Correct artificial negative concentrations
+         IF( ln_zps    )        CALL zps_hde( kstp, jptra, trn, gtru, gtrv )  ! Partial steps: now horizontal gradient of passive
+                                                                ! tracers at the bottom ocean level
+         !
+      ELSE                                               ! 1D vertical configuration
+                                CALL trc_sbc( kstp )            ! surface boundary condition
+         IF( .NOT. lk_offline .AND. lk_zdfkpp )    &
+            &                   CALL trc_kpp( kstp )            ! KPP non-local tracer fluxes
+                                CALL trc_zdf( kstp )            ! vertical mixing and after tracer fields
+                                CALL trc_nxt( kstp )            ! tracer fields at next time step     
+          IF( ln_trcrad )       CALL trc_rad( kstp )            ! Correct artificial negative concentrations
+         !
+      END IF
       !
    END SUBROUTINE trc_trp
